import obs, uasyncio
from modbus import modbus
from sensor_drv import SensorDrv

class modbus_seametrics(SensorDrv):
    def __init__(self, serial, conf):
        SensorDrv.__init__(self)
        self.syslog = obs.system_log('modbus_seametrics')
        self.modbus_obj = modbus(serial, conf)
 
    async def read_values(self):
        #A register read triggers the sensor to start a measurement
        if await self.modbus_obj.read_values():
            #The first read is discarded, according the manual there must be a wait time of 1 second between readings, in practice this takes a little longer
            await uasyncio.sleep_ms(1500)
            if await self.modbus_obj.read_values() == True:
                self.data = self.modbus_obj.data
                return True
        return False

    async def detect_parameters(self, tag_number = ''):
        if await self.modbus_obj.detect_parameters(tag_number):
            self.parameters = self.modbus_obj.parameters
            return True
        return False

    async def flush(self):
        #Not required
        pass
    
